'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _objectDestructuringEmpty2 = require('babel-runtime/helpers/objectDestructuringEmpty');

var _objectDestructuringEmpty3 = _interopRequireDefault(_objectDestructuringEmpty2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

require('isomorphic-fetch');

var _queryString = require('query-string');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getNested = require('get-nested'); // tslint:disable-line:no-var-requires
var deepmerge = require('deepmerge/dist/umd'); // tslint:disable-line:no-var-requires
var propertiesToHydrate = ['tokensToVerify', 'user', 'data'];

var Site = function () {
    function Site(initParams) {
        (0, _classCallCheck3.default)(this, Site);

        this.initialized = false;
        // Created when initializing
        this.url = null;
        this.fetchOptions = {};
        // Can be hydrated and dehydrated
        this.tokensToVerify = [];
        this.user = null;
        this.data = {
            data: {},
            paths: {},
            __hn: {}
        };
        // Not hydrated
        this.pagesLoading = {};
        this.pagesLoaded = {};
        this.reset();
        if (initParams) this.initialize(initParams);
    }

    (0, _createClass3.default)(Site, [{
        key: 'initialize',
        value: function initialize(_ref) {
            var url = _ref.url,
                _ref$fetchOptions = _ref.fetchOptions,
                fetchOptions = _ref$fetchOptions === undefined ? {} : _ref$fetchOptions;

            if (this.initialized) throw Error('The site is already initialized.');
            this.initialized = true;
            this.url = url;
            this.fetchOptions = fetchOptions;
        }
    }, {
        key: 'reset',
        value: function reset() {
            this.initialized = false;
            this.url = null;
            this.tokensToVerify = [];
            this.user = null;
            this.data = {
                data: {},
                paths: {},
                __hn: {}
            };
            this.pagesLoading = {};
            this.pagesLoaded = {};
        }
        /**
         * Creates an object that can be hydrated by the hydrate function.
         */

    }, {
        key: 'dehydrate',
        value: function dehydrate() {
            var _this = this;

            var dehydrated = {};
            propertiesToHydrate.forEach(function (property) {
                dehydrated[property] = _this[property];
            });
            return dehydrated;
        }
        /**
         * Updates all properties with the object created by the dehydrate function.
         */

    }, {
        key: 'hydrate',
        value: function hydrate(options) {
            var _this2 = this;

            propertiesToHydrate.forEach(function (property) {
                _this2[property] = options[property];
            });
        }
    }, {
        key: 'fetch',
        value: function (_fetch) {
            function fetch(_x) {
                return _fetch.apply(this, arguments);
            }

            fetch.toString = function () {
                return _fetch.toString();
            };

            return fetch;
        }(function (path) {
            var _this3 = this;

            var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

            if (!this.initialized) {
                throw Error('Site is not intitialized. Pass an object when creating a site, or use the ' + 'initialize method.');
            }
            return fetch(this.url + path, (0, _assign2.default)({ method: 'GET', mode: 'cors', cache: 'default' }, options, this.fetchOptions)).then(function (response) {
                if (!response.ok) {
                    throw Error('Error at path: ' + (_this3.url + path) + ': ' + response.status + ' - ' + response.statusText);
                }
                return response.json();
            });
        })
    }, {
        key: 'getPage',
        value: function getPage(path) {
            var _this4 = this;

            var loadFromServer = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

            if (!loadFromServer) {
                var uuid = this.getUuid(path);
                // If we already loaded the page (either directly or via another page),
                // we can return it right now.
                if (uuid) return _promise2.default.resolve(uuid);
                // If we're already loading this page, we should return the promise.
                if (this.pagesLoading[path]) return this.pagesLoading[path];
            }
            // Copy this.tokensToVerify for this single request.
            var tokensToVerify = [].concat((0, _toConsumableArray3.default)(this.tokensToVerify));
            this.pagesLoading[path] = this.fetch('/hn?' + (0, _queryString.stringify)({
                path: path,
                _format: 'hn',
                _hn_user: this.user ? this.user : undefined,
                _hn_verify: tokensToVerify
            })).then(function (page) {
                var hnRequestData = page.__hn && page.__hn.request && page.__hn.request || {};
                // Get the user id, to pass to all new requests.
                _this4.user = hnRequestData.user || _this4.user;
                // Remove all sent tokens from the tokensToVerify.
                _this4.tokensToVerify = _this4.tokensToVerify.filter(function (t) {
                    return tokensToVerify.indexOf(t) === -1;
                });
                // Add new token to tokensToVerify.
                var newToken = hnRequestData.token;
                if (newToken) _this4.tokensToVerify.push(newToken);
                // Add all data to the global data storage.
                _this4.addData(page);
                // Mark this promise as loaded
                var uuid = _this4.data.paths[path];
                _this4.pagesLoaded[path] = uuid;
                // Delete the reference to this promise, because we're not loading anymore.
                delete _this4.pagesLoading[path];
                return uuid;
            });
            return this.pagesLoading[path];
        }
    }, {
        key: 'getUuid',
        value: function getUuid(path) {
            // If we already loaded the page, we can return it right now.
            if (this.pagesLoaded[path]) return this.pagesLoaded[path];
            // Maybe we already have the data from another fetch.
            try {
                // We try to get the data directly. If the data isn't available, that's fine.
                var uuid = this.data.paths[path];
                if (this.getData(uuid).__hn.view_modes.includes('default')) {
                    return uuid;
                }
            } catch (_a) {
                // The data probabily doesn't exist yet, so we do nothing.
            }
        }
    }, {
        key: 'addData',
        value: function addData(data) {
            this.data = deepmerge(this.data, data, { arrayMerge: function arrayMerge(_ref2, b) {
                    (0, _objectDestructuringEmpty3.default)(_ref2);
                    return b;
                } });
        }
    }, {
        key: 'getData',
        value: function getData(key) {
            return this.data.data[key];
        }
        /**
         * * Translate ninja
         * Get the translations from the settings block.
         * Gets the language from context, or from parameter if overruled.
         * Returns input string when no translations are available.
         * @param string
         * @param langCode
         * @return {*}
         */
        // tslint:disable-next-line function-name

    }, {
        key: 't',
        value: function t(string, langCode) {
            var _this5 = this;

            var settings = this.getData('settings');
            var path = this.data.paths[window.location.pathname];
            var lang = langCode || getNested(function () {
                return _this5.getData(path).langcode;
            }, 'en');
            return getNested(function () {
                return settings.translations[string][lang];
            }, string);
        }
    }]);
    return Site;
}();

exports.default = Site;
//# sourceMappingURL=Site.js.map
